

class ServiceTransform(object):
    __parameters = {}

    DATE = 0
    TIME = 1
    PRESSURE = 2
    HYGROSCOPY = 3
    TEMPERATURE = 4
    
    def __init__(self):
        pass


    def translate(self, aUser, aFile):
        self.__logger.inform('Translating legacy data file ' + aFile)
        lPath, lFilename = os.path.split(aFile)
        os.chdir(lPath)
        if not os.path.isfile(lFilename):
            self.__logger.warn(lFilename + ' is not a file.')
            return
        
        lInFile = open(lFilename, 'r')
        lOutFile = None
        lLine = None
        lFutureDate = datetime.datetime(1970, 1, 1)
        while lLine != '':
            lDate, lLine = self.__translateLine(lInFile.readline())
            if lLine != '':
                if lDate > lFutureDate:
                    lCurrentDate, lFutureDate = self.__getWeekDatesFor(lDate)
                    lOutFile = self.__openOutFile(lOutFile, aUser, lCurrentDate)
                lOutFile.write(lLine)

        lInFile.close()
        lOutFile.close()

    def __translateLine(self, aLine):
        if aLine == '':
            return None, ''

        lSplitLine = aLine.split()
        lDate = self.__getDateFor(lSplitLine)
        lNewLine = lSplitLine[self.DATE] + ':' + \
                   lSplitLine[self.TIME].replace(':', '/') + ':' + \
                   lSplitLine[self.TEMPERATURE] + ':' + \
                   lSplitLine[self.PRESSURE] + ':' + \
                   lSplitLine[self.HYGROSCOPY] + os.linesep
        return lDate, lNewLine

    def __openOutFile(self, aFile, aUser, aDate):
        """Opens or reopens a new result file for the translation.
        """
        if aFile != None and not aFile.closed:
            aFile.close()
        lOutFilename = aUser + '-' + time.strftime('%Y%m%d', aDate.timetuple())
        self.__logger.log('creating new file ' + lOutFilename)
        return open(lOutFilename, 'w')
        
    def __getDateFor(self, aSplitLine):
        lDay, lMonth, lYear = aSplitLine[self.DATE].split('/')
        return datetime.datetime(int(lYear), int(lMonth), int(lDay))

    def __getWeekDatesFor(self, aDate):
        """Returns the date of the beginning of the concerned week.
        """
        lTuple = aDate.timetuple()
        if lTuple.tm_wday == 6:
            lNextDelta = datetime.timedelta(days = 7)
            print "DEBUG ** __getWeekDatesFor returning " + aDate, aDate+lNextDelta
            return aDate, aDate + lNextDelta
        else:
            lPrevDelta = datetime.timedelta(days = - (lTuple.tm_wday + 2))
            lNextDelta = datetime.timedelta(days = 7 - (lTuple.tm_wday + 2))
            print "DEBUG ** __getWeekDatesFor returning(2) " + aDate+lPrevDate, aDelta+lNextDelta
            return aDate + lPrevDelta, aDate + lNextDelta


